% read data
format long e
clear all

'****************************'

offcorr=0;
driftcorr=0;

% v1 Time
% v2 Plate
% v3 LED
% v4 MEMS
% v5 Shield
% v6 outside can
% v7 data
% v8 PD

% number of parameter to regress 
% 1=T1,T2,T3,T4,off
% 2=T1,T2,T3,T4,off,lin
% 3=T1,T2,T3,T4,off,Tides
% 4=T1,T2,T3,T4,off,Tides,lin


Nreg=2;
Ns=1;

%smooth=1, no smooth=0
smth=1; 

%Calibration Correction Factor: (the higher, the smaller the amplitude)
fac=1.3

% tide smoothing (always on) (average data) (600 for ten min sampling)
Nsg=1;

%resample data
down=10;

%day of year
DOY=69;

download=datenum(2015,3,22,10,03,00)

tidedata=datenum(2015,3,10,00,00,00)

%download=datenum(2015,2,6,11,11,00)
%datenum(now);

% Read in data files
%fid1=fopen('overnight_temp_old.txt');
fid1=fopen('voltage_and_temperatures.txt');
variable1 = textscan(fid1,'%f32 %f32 %f32 %f32 %f32 %f32 %f32 %f32');
fclose(fid1);

Nstart=10100;
Nend=length(variable1{1})-11360;

fid2=fopen('Tidal_Correction_10Mar_15days.txt');
variable2 = textscan(fid2,'%f32 %f32 %f32:%f32:%f32 %f32 %f32 %f32');
fclose(fid2);
tide_t=(variable2{2}'+(variable2{3}'+(variable2{4}'/60))/24)-DOY;
tide_amp=variable2{8}';


cal=96500*fac

v1=variable1{1}';
v2=variable1{2}';
v3=variable1{3}';
v4=variable1{4}';
v5=variable1{5}';
v6=variable1{6}';
v7=variable1{7}';
v8=variable1{8}';


tau=0;

t_data=v1(Nstart:Nend);

% time of download
tinitial=double(datenum(download)-v1(length(v1))/86400);
starttime=datestr(tinitial);
tt_in=datevec(tinitial);

hh=tt_in(4);
mm=tt_in(5);
ss=tt_in(6);

prog_start=(hh+mm/60+ss/3600)/24

datastart=datestr(double(tinitial+v1(Nstart)/86400));
dat_in=datevec(datastart);

% date offset for tide plotting (value is integerised)
date_offset=floor(datenum(dat_in)-tidedata);


hh_data=dat_in(4);
mm_data=dat_in(5);
ss_data=dat_in(6);

data_start=(hh_data+mm_data/60+ss_data/3600)/24;

t_data=(t_data-t_data(1))/86400+data_start;

t_data=t_data+date_offset;

y_data=v7(Nstart+tau:Nend+tau);
y_data=(y_data-mean(y_data))./cal;

t_ds=downsample(t_data,down);

T1=v4(Nstart:Nend);
mean_T1=mean(T1);
T1=T1-mean_T1;

T2=v3(Nstart:Nend);
mean_T2=mean(T2);
T2=T2-mean_T2;

T3=v6(Nstart:Nend);
mean_T3=mean(T3);
T3=T3-mean_T3;

T4=v5(Nstart:Nend);
mean_T4=mean(T4);
T4=T4-mean_T4;

T5=v2(Nstart:Nend);
mean_T5=mean(T5);
T5=T5-mean_T5;

PD=v8(Nstart:Nend);
mean_PD=mean(PD);
PD=PD-mean_PD;

if smth==1
T1s=smooth(T1,Ns)';
T2s=smooth(T2,Ns)';
T3s=smooth(T3,Ns)';
T4s=smooth(T4,Ns)';
T5s=smooth(T5,Ns)';
PDs=smooth(PD,Ns)';
%y_datas=smooth(y_data,Ns)';
else
T1s=T1;
T2s=T2;
T3s=T3;
T4s=T4;
T5s=T5;
PDs=PD;
%y_datas=y_data;
end
y_datas=y_data;

T1_ds=downsample(T1s,down);
T2_ds=downsample(T2s,down);
T3_ds=downsample(T3s,down);
T4_ds=downsample(T4s,down);
T5_ds=downsample(T5s,down);
PD_ds=downsample(PDs,down);
y_data_ds=downsample(y_datas,down);

figure(1)
plot(t_ds,T1_ds,'k')
hold on
plot(t_ds,T2_ds,'r')
hold on
plot(t_ds,T3_ds,'b')
hold on
plot(t_ds,T4_ds,'g')
%legend ('MEMS', 'Shield')
legend ('MEMS','LED', 'Outside', 'Shield')
title('Temperature Variation')


% interpolate tide data

tsig=interp1(tide_t,tide_amp,t_ds);

%tsig=tsig(Nstart:Nend);
if smth==1
signal=smooth(tsig,Ns)';
else
signal=tsig;
end

signal_ds=downsample(signal,down);


ntot=length(y_data_ds);
refine=1e-5;

d_lambda=refine;

[row,col] = find(d_lambda);

% starting parameters

%offset
off1=0;
%drift1 (linear)
off2=0;
%drift1 (poly 2nd order)
off3=0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if Nreg==1
ampT1=0.01;
ampT2=0.01;
ampT3=0.01;
ampT4=0.01;

b=[off1 off2 ampT1 ampT2 ampT3 ampT4];

ntot
count=0;
for i=1:ntot    
y(i)=off1+off2*t_ds(i)+ampT1*T1_ds(i)+ampT2*T2_ds(i)+ampT3*T3_ds(i)+ampT4*T4_ds(i);
d_beta(i)=y_data_ds(i)-y(i); 
df_d0(i)=1; 
df_d1(i)=t_ds(i); 
df_d2(i)=T1_ds(i);
df_d3(i)=T2_ds(i);
df_d4(i)=T3_ds(i);
df_d5(i)=T4_ds(i);
count=count+1;
end

al=['df_d0 :';'df_d1 :'; 'df_d2 :';'df_d3 :'; 'df_d4 :'; 'df_d5 :';];
Xd=[df_d0; df_d1; df_d2; df_d3; df_d4; df_d5; y_data_ds];
P=mregg(Xd,0,0,al);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

elseif Nreg==2
ampT1=0.01;
ampT2=0.01;
ampT3=0.01;
ampT4=0.01;

b=[off1 off2 ampT1 ampT2 ampT3 ampT4];

ntot
count=0;
for i=1:ntot    
y(i)=off1+off2*t_ds(i)+ampT1*T1_ds(i)+ampT2*T2_ds(i)+ampT3*T3_ds(i)+ampT4*T4_ds(i);
d_beta(i)=y_data_ds(i)-y(i); 
df_d0(i)=1; 
df_d1(i)=t_ds(i); 
df_d2(i)=T1_ds(i);
df_d3(i)=T2_ds(i);
df_d4(i)=T3_ds(i);
df_d5(i)=T4_ds(i);
count=count+1;
end

al=['df_d0 :';'df_d1 :'; 'df_d2 :';'df_d3 :'; 'df_d4 :'; 'df_d5 :';];
Xd=[df_d0; df_d1; df_d2; df_d3; df_d4; df_d5; y_data_ds];
P=mregg(Xd,0,0,al);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


elseif Nreg==3
ampT1=0.01;
ampT2=0.01;
ampT3=0.01;
ampT4=0.01;
ampsignal=0.01

b=[off1 off2 ampT1 ampT2 ampT3 ampT4 ampsignal];

ntot
count=0;
for i=1:ntot    
y(i)=off1+off2*t_ds(i)+ampT1*T1_ds(i)+ampT2*T2_ds(i)+ampT3*T3_ds(i)+ampT4*T4_ds(i)+ampsignal*signal(i);
d_beta(i)=y_data_ds(i)-y(i); 
df_d0(i)=1; 
df_d1(i)=t_ds(i); 
df_d2(i)=T1_ds(i);
df_d3(i)=T2_ds(i);
df_d4(i)=T3_ds(i);
df_d5(i)=T4_ds(i);
df_d6(i)=signal(i);
count=count+1;
end

al=['df_d0 :';'df_d1 :'; 'df_d2 :';'df_d3 :'; 'df_d4 :'; 'df_d5 :'; 'df_d6 :';];
Xd=[df_d0; df_d1; df_d2; df_d3; df_d4; df_d5; df_d6; y_data_ds];
P=mregg(Xd,0,0,al);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

elseif Nreg==4
ampT1=0.01;
ampT2=0.01;
ampT3=0.01;
ampT4=0.01;
ampsignal=0.01

b=[off1 off2 ampT1 ampT2 ampT3 ampT4 ampsignal];

ntot
count=0;
for i=1:ntot    
y(i)=off1+off2*t_ds(i)+ampT1*T1_ds(i)+ampT2*T2_ds(i)+ampT3*T3_ds(i)+ampT4*T4_ds(i)+ampsignal*signal(i);
d_beta(i)=y_data_ds(i)-y(i); 
df_d0(i)=1; 
df_d1(i)=t_ds(i); 
df_d2(i)=T1_ds(i);
df_d3(i)=T2_ds(i);
df_d4(i)=T3_ds(i);
df_d5(i)=T4_ds(i);
df_d6(i)=signal(i);
count=count+1;
end

al=['df_d0 :';'df_d1 :'; 'df_d2 :';'df_d3 :'; 'df_d4 :'; 'df_d5 :'; 'df_d6 :';];
Xd=[df_d0; df_d1; df_d2; df_d3; df_d4; df_d5; df_d6; y_data_ds];
P=mregg(Xd,0,0,al);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

else
'wrong number'
end




initial=1;

S=sum(initial)^2;

u=ones(1,ntot);

if Nreg==1
y_fit=(P(1)+offcorr)+(P(2)+driftcorr).*t_ds+P(3).*T1_ds+P(4).*T2_ds+P(5).*T3_ds+P(6).*T4_ds;

elseif Nreg==2
y_fit=(P(1)+offcorr)+(P(2)+driftcorr).*t_ds+P(3).*T1_ds+P(4).*T2_ds+P(5).*T3_ds+P(6).*T4_ds;

elseif Nreg==3
y_fit=(P(1)+offcorr)+(P(2)+driftcorr).*t_ds+P(3).*T1_ds+P(4).*T2_ds+P(5).*T3_ds+P(6).*T4_ds+P(7).*signal;

elseif Nreg==4
y_fit=(P(1)+offcorr)+(P(2)+driftcorr).*t_ds+P(3).*T1_ds+P(4).*T2_ds+P(5).*T3_ds+P(6).*T4_ds+P(7).*signal;

else
'wrong number'
end

yres_ds=y_data_ds-y_fit;

sum_square=sqrt(sum(yres_ds.^2)/(ntot-1))

figure(3)
subplot(2,1,1),plot(t_ds,y_fit,':r')
hold on
plot(t_ds,y_data_ds,'k')
hold on
subplot(2,1,2),plot(t_ds,yres_ds,':r')
title('Fit Data')

P

% average data

ynew=smooth(yres_ds,Nsg)';


if Nreg==2
off=-30;
elseif Nreg==4
    off=-30
else
    off=0
end

ynew=(2*pi*2.31)^2.*ynew.*1e8+off;
Linear=P(2).*(2*pi*2.31)^2.*1e8;

    
Nstart2=50;
Nend2=length(ynew)-1419;
ynew=ynew(Nstart2:Nend2);
t_ds2=t_ds(Nstart2:Nend2);
signal2=signal(Nstart2:Nend2);

if Nreg==1
    ynew=(ynew-Linear.*t_ds2);
    off2=-mean(ynew);
    ynew=ynew+off2;
elseif Nreg==3
    ynew=(ynew-Linear.*t_ds2);
    off2=-mean(ynew);
    ynew=ynew+off2;
end
    


figure(4)
if Nreg==1
    plot(t_ds2,ynew,'x-')
    ylabel('Sensitivity (micro-Gal)')
    xlabel('Time (days)')
    title('Tide Data')
elseif Nreg==3
    plot(t_ds2,ynew,'x-')
    ylabel('Sensitivity (micro-Gal)')
    xlabel('Time (days)')
    title('Tide Data')
elseif Nreg==4
    plot(t_ds2,ynew,'x-')
    ylabel('Sensitivity (micro-Gal)')
    xlabel('Time (days)')
    title('Tide Data')
else
    plot(t_ds2,ynew,'x-')
    hold on
    plot(t_ds2,signal2,'r')
    ylabel('Sensitivity (micro-Gal)')
    xlabel('Time (days)')
    title('Tide Data')
end
    
if Nreg==2   
Standard_Deviation=std(t_ds)
%Calculate Correlation Coefficient:
Corr=corrcoef(ynew,signal2);
Corr=Corr(2,1)

%Calculate Correlation Coefficient for i randomised data sets
for i=1:10000
   R=ynew(randperm(length(ynew)));
   Corr_rand=corrcoef(R,signal2);
   test(i)=Corr_rand(2,1);
end

%Plot histogram of randomised data sets
figure(5)
hist(test)

%Calculate Sigma Value:
Sigma=Corr/std(test)

end









figure(6)
if Nreg==1
plot(t_ds,(P(1)+offcorr).*t_ds./t_ds)
hold on
plot(t_ds,(P(2)+driftcorr).*t_ds,'k')
hold on
plot(t_ds,P(3).*T1_ds,'b')
hold on
plot(t_ds,P(4).*T2_ds,'b')
hold on
plot(t_ds,P(5).*T3_ds,'k-')
hold on
plot(t_ds,P(6).*T4_ds,'y-')
legend ('Offset', 'Linear Drift','MEMS','LED','Outside','Shield')
title('Regressed Parameters')

elseif Nreg==2
plot(t_ds,(P(1)+offcorr).*t_ds./t_ds)
hold on
plot(t_ds,P(2).*T1_ds,'b')
hold on
plot(t_ds,P(3).*T2_ds,'b')
hold on
plot(t_ds,P(4).*T3_ds,'k-')
hold on
plot(t_ds,P(5).*T4_ds,'y-')
legend ('Offset','MEMS','LED','Outside','Shield')
title('Regressed Parameters')

elseif Nreg==3
plot(t_ds,(P(1)+offcorr).*t_ds./t_ds)
hold on
plot(t_ds,(P(2)+driftcorr).*t_ds,'k')
hold on
plot(t_ds,P(3).*T1_ds,'b')
hold on
plot(t_ds,P(4).*T2_ds,'b')
hold on
plot(t_ds,P(5).*T3_ds,'k-')
hold on
plot(t_ds,P(6).*T4_ds,'y-')
hold on
plot(t_ds,P(7).*t_ds,'r')
legend ('Offset', 'Linear Drift','MEMS','LED','Outside','Shield','Tides')
title('Regressed Parameters')

elseif Nreg==4
plot(t_ds,(P(1)+offcorr).*t_ds./t_ds)
hold on
plot(t_ds,P(2).*T1_ds,'b')
hold on
plot(t_ds,P(3).*T2_ds,'b')
hold on
plot(t_ds,P(4).*T3_ds,'k-')
hold on
plot(t_ds,P(5).*T4_ds,'y-')
hold on
plot(t_ds,P(6).*t_ds,'r')
legend ('Offset','MEMS','LED','Outside','Shield','Tides')
title('Regressed Parameters')

else
'wrong number'
end
'****************************'




% allan variance code

tsample=1;
N=length(ynew);
ydata=ynew;
t=t_ds2*86400;
allan_count=0;

% start with 2 clusters and end with N clusters

for K=2:N/5;
   
    % determine data points per cluster (N points split into K clusters)
    M=floor(N/K);
 
    % average of each cluster 
    for j=1:K;
    avgcluster(j)=sum(ydata((j-1)*M+1:j*M))/M; 
    end
    
    % perform allan variance
    allan_count=allan_count+1;
    sum_allan=0;
    for j=1:K-1
        
    %time cluster size
    tau(j)=((t(N)-t(1))/(j+1));
    sum_allan=(avgcluster(j+1)-avgcluster(j))^2+sum_allan;
    end
    K
    allan_variance(allan_count)=sum_allan/(2*(K-1));
    
    clearvars avgcluster
    
end

figure(7)
loglog(tau,allan_variance.^0.5)
%hold on


% Estimate sampling time and frequency
nsamp=length(t_ds);
ts=(t_ds(nsamp)-t_ds(1))/nsamp;
fs=1/ts/86400;

% Calculate the PSD
[Px,f]=pwelch(ynew,[],[],[],fs); %In units of uGal^2/Hz

% Calculate the ASD
%asdx=(Px.^0.5).*(f.^0.5);

%Px=Px/1e12; %convert from uGal^2/Hz to Gal^2/Hz
%Px=Px/10000; %convert from Gal^2/Hz to (m/s^2)^2/Hz
%Px=Px*1e18; %convert from (m/s^2)^2/Hz to (nm/s^2)^2/Hz

figure(8)
loglog(f,Px,'r')
%grid on
%grid minor
title('Power Spectral Density')



%ntot=length(t_ds);
%ts=86400*(t_ds(ntot)-t_ds(1))/ntot;
%fs=1/ts;
% Calculate the PSD
%[Px,f]=pwelch(ynew,[],[],[],fs);
%Px=10.*log10(Px);
%figure(9)
%loglog(f,Px)

% %%%%%%%%%%%%%%%%%%%%FAST SAMPLING%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% N=1
% %fac2=1;
% %cal=(160000/1.5)*fac2;
% 
% for i=1:N
% 
% filename=cat(2,'test',num2str(i),'.txt')    
%     
% fid1=fopen(filename);
% variable1 = textscan(fid1,'%f32 %f32');
% fclose(fid1);
% 
% v1=variable1{1}';
% v2=variable1{2}';
% 
% v2=v2-mean(v2);
% 
% t_temp(:,i)=v1;
% y_temp(:,i)=((v2./cal).*(2*pi*2.31).^2).*1e8;
% 
% coeff=polyfit(t_temp,y_temp,1);
% 
% y_temp=y_temp-(coeff(1).*t_temp+coeff(2));
% 
% end
% 
% % average data
% 
% tval=0;
% yval=0;
% 
% for i=1:N
% tval=t_temp(:,i)+tval;
% yval=y_temp(:,i)+yval;
% end
% 
% t_data=tval/N;
% y_data=yval/N;
% 
% 
% 
% tsample=1;
% N=length(y_data);
% ydata=y_data;
% t=t_data
% allan_count=0;
% 
% % start with 2 clusters and end with N clusters
% 
% for K=2:N/40
%    
%     % determine data points per cluster (N points split into K clusters)
%     M=floor(N/K);
%  
%     % average of each cluster 
%     for j=1:K
%     avgcluster(j)=sum(ydata((j-1)*M+1:j*M))/M; 
%     end
%     
%     % perform allan variance
%     allan_count=allan_count+1;
%     sum_allan=0;
%     for j=1:K-1
%         
%     %time cluster size
%     tau(j)=((t(N)-t(1))/(j+1));
%     sum_allan=(avgcluster(j+1)-avgcluster(j))^2+sum_allan;
%     end
%     K
%     allan_variance(allan_count)=sum_allan/(2*(K-1));
%     
%     clearvars avgcluster
%     
% end
% 
% %allan_variance
% %loglog(tau,allan_variance)
% 
% loglog(tau,allan_variance.^0.5)
% 
% figure(6)
% plot(t_data,y_data);
