% read data
format long e
clear all

cal=160000/1.5;

'****************************'

% Read in data file
%fid1=fopen('overnight_temp_old.txt');

N=5
%N=39;

for i=1:N

filename=cat(2,'test',num2str(i),'.txt')    
    
fid1=fopen(filename);
variable1 = textscan(fid1,'%f32 %f32');
fclose(fid1);

v1=variable1{1}';
v2=variable1{2}';

v2=v2-mean(v2);

t_temp(:,i)=v1;
y_temp(:,i)=((v2./cal).*(2*pi*2.2).^2)./(1e-9*9.81);
%y_temp(:,i)=((v2./cal).*(2*pi*2.2).^2);

coeff=polyfit(t_temp,y_temp,1);

y_temp=y_temp-(coeff(1).*t_temp+coeff(2));

end

% average data

tval=0;
yval=0;

for i=1:N
tval=t_temp(:,i)+tval;
yval=y_temp(:,i)+yval;
end

t_data=tval/N;
y_data=yval/N;

% figure(1)
% subplot(2,1,1)
% plot(t_temp,y_temp)
% hold on
% subplot(2,1,2)
% plot(t_data,y_data)

% Estimate sampling time and frequency
nsamp=length(t_data);
% frequency in "days"
ts=(t_data(nsamp)-t_data(1))/nsamp;

fs=1/ts;

asdtemp=0;

for i=1:N

yval=y_temp(:,i);

yval=yval-mean(yval);


% Calculate the PSD
[Px,f2]=pwelch(yval,[],[],[],fs);

% Calculate the ASD
asdx2=(Px.^0.5).*(f2.^0.5);%./(1./sqrt(f2));
single(:,i)=asdx2;
asdtemp=asdtemp+asdx2;
end

asdtemp=asdtemp/N;

figure
%subplot(2,1,2)
%loglog(f2,single)
%hold on
%subplot(2,1,1)
loglog(f2,asdtemp,'k')

% figure(3)
% subplot(2,1,2)
% semilogx(f2,single)
% hold on
% subplot(2,1,1)
% semilogx(f2,asdtemp,'k')


